## 0.0.1 First Package

Includes:
- Full replication based on the defined strategies
- Listeners to achieve event based replication
- Pairing bug fixing
- Replication of :Global data from Cloud to Local 

## 0.0.2 Declaration Update

Includes:
- Modified from Declaration.doShareData to Declaration.doNotShareData

## 0.0.3 :Global bug fixing

Includes:
- Bug fixing related to :Global:Recommendations
- Bug fixing related to :Global:profiles
- Bug fixing related to :Global:threats

## 0.0.4 :Global:Recommendations bug fixing

Includes:
- Bug fixing related to :Global:Recommendations. Sets a correct relation between :Global:threats and :Global:Recommendations['relatedThreatsWeights']

## 0.0.5 :Global:threats update

Includes:
- Bug fixing/update related to :Global:threats. Updates with a new method to get GEIGER threats from GEIGER Cloud API

## 0.0.6 :Global:Recommendations bugfix

Includes:
- Bug fixing to :Global:Recommendations. Adapt to 0.0.5 update.

## 0.0.7 :Global:Recommendations bugfix

Includes:
- Bug fixing to :Global:Recommendations. Adapt to 0.0.5 update. 
- 0.0.6 was not updating :Global:Recommendations['relatedThreatsWeights'] when :Global:Recommendations node was not found.

## 0.0.8 :Global:profiles

Includes:
- Modified Search Criteria to match :Global:threats['GEIGER_threat'] and compare to :Global:threats['name']. Must match.

## 0.0.9 Pairing

Includes:
- Updated consistency of the paired data under :pairing_plugin node.

## 0.0.10 :Global:Recommendations bugfix

Includes:
- Bug fixing to :Global:Recommendations. Adapt to 0.0.8 update. 
- 0.0.9 was not updating :Global:Recommendations['relatedThreatsWeights'] as expected. Must match SC :Global:threats['GEIGER_threat'] and compare to :Global:threats['name'] to get the UUID of the Threat.

## 0.1.0 Pairing

Includes:
- Pairing Bug fixing
- Updates :Keys SearchCriteria
- Creates :Enterprise:Users:id:pairingStructure

## 0.1.1 Handler Fix

Includes:
- Bugfix related to Listener Handlers

## 0.1.2 :Keys Fix

Includes:
- Random UUID for :Keys

## 0.1.3 Overriding Issue

Includes:
- Issue with updated nodes and children

## 0.1.4 KEY Issue

Includes:
- Keys work with Search Criteria. In case of conflict -> Check the values inside the node

## 0.1.5 KEY Issue

Includes:
- Keys work with Search Criteria. In case of conflict -> Check the values inside the node

## 0.1.6 Listeners Improvement

Includes:
- Event listener were not working properly (replication & pairing issues) -> Solved.
- When pairing plugin updates a toolbox node, it should not be replicated to the cloud (comes from it) -> Solved.
- Full integrated tests:
  1. Full Replication (Setting listeners but no usage)
  2. Full Replication (Setting listeners and usage: CREATE; DELETE; UPDATE; RENAME)
  3. Pairing (2 previous replicated users)
  4. Pairing with listeners (Modifies nodes while Listeners are running & after pairing)

## 0.1.7 Recommendations Improvement

Includes:
- Loop though Recommendations['Steps']

## 0.1.8 Connection Issue

Includes:
- Improves REST API connection handling

## 0.1.9 GEIGER API UPGRADE

Includes:
- Improves REST API connection handling

## 0.1.10 GEIGER API UPGRADE v2

Includes:
- Solves Geiger API 0.7.5

## 0.1.11 Update Search Criteria

Includes:
- Upgrade SearchCriteria

## 0.1.12 Static Analysis

Includes:
- flutter format to match criteria

## 0.1.23 Static Analysis

Includes:
- new version of cloud adapter

## 0.1.24 Static Analysis

Includes:
- new library name

## 0.1.25 Static Analysis

Includes:
- new library name

## 0.1.26 Pairing and listeners improvements

Includes:
- Bug fixing related to device and employee pairing
- Bug fixing related to listeners

## 0.1.27 Merge and Unpair improvements

Includes:
- Bug fixing related to unpairing
- Bug fixing related to merge accounts

## 0.1.28 Cloud Connection

Includes:
- Bug fixing related to cloud connection

## 0.1.29 Geiger API upgrade

Includes:
- Upgrade version 0.8.0 of geiger_api
- Upgrade version 0.8.0 of geiger_localstorage
- Upgrade version 0.8.0 of geiger_localstorage

## 0.1.30 Cloud Connected Tool Event / Recommendation / Status Recommendation

Includes:
- New way of getting Cloud Connected Tool Events / Recommendation / Status Recommendation

## 0.1.31 Listeners upgrade

Includes:
- Upgrade Listeners to update aggregate_score event types
- Bug fixing related to username changed

## 0.1.32 Sensor and training cloud events upgrade

Includes:
- Bug fixing related to Cloud Connected Tool Event / Recommendation / Status Recommendation 

## 0.1.33 HttpClient Cloud service

Includes:
- Bug fixing related to Cloud Connected Tool Event / Recommendation / Status Recommendation 
- HttpClient cloud service by environment now
- Performance improvement for replication

## 0.1.34 Assets in package

Includes:
- Renaming to include assets in the package

## 0.1.35 Assets in package

Includes:
- Bug fixing related to assets included

## 0.1.36 Assets in package

Includes:
- Bug fixing related to assets included

## 0.1.37 Score Improvement

Includes:
- Bug fixing cloud and replication service
- Bug fixing related to assets included

## 0.1.38 Example added

Includes:
- Bug fixing and general clean up to make standards 
- Included example