import 'dart:io';

import 'package:cloud_adapter/src/service/cloud_service/cloud_service.dart';
import 'package:flutter_dotenv/flutter_dotenv.dart';
import 'package:test/test.dart';

void main() {
  group('development', () {
    setUp(() {
      dotenv.testLoad(fileInput: File('lib/asset/env.development').readAsStringSync());
    });
    test('api uri loaded', () async {
      expect(dotenv.env['API_URI'], 'https://37.48.101.252:8443/geiger-cloud/api');
    });
    test('cert path loaded', () async {
      expect(dotenv.env['CERT_PATH'], 'packages/cloud_adapter/lib/asset/resources/cloud_adapter_client.p12');
    });
  });

  group('production', () {
    setUp(() {
      dotenv.testLoad(fileInput: File('lib/asset/env.production').readAsStringSync());
    });
    test('api uri loaded', () async {
      expect(dotenv.env['API_URI'], 'https://cloud.geiger.cat/geiger-cloud/api');
    });
    test('cert path loaded', () async {
      expect(dotenv.env['CERT_PATH'], 'packages/cloud_adapter/lib/asset/resources/cloud_adapter_client.p12');
    });
  });
}